// Module Name: maze.cpp
// Author:      Stephen Manley (smanley@nyx.net)
//
// Description:
// 
// This class represents the walls in a maze. They have a set of
// coordinates which define it's position, a style with which
// they can draw themselves, and the ability to toggle on and
// off.
//
///////////////////////////////////////////////////////////////////////////

#ifndef WALL
#define WALL

class Wall
{
	public:

		// Constructors / Destructors
		Wall(	double xx1, double yy1, double zz1,
				double xx2, double yy2, double zz2,
				double xx3, double yy3, double zz3,
				double xx4, double yy4, double zz4);

		Wall();
		~Wall();

		// Operations
		void draw();
		void drawWall1(	double cx1, double cy1, double cz1,
						double cx2, double cy2, double cz2,
						double cx3, double cy3, double cz3,
						double cx4, double cy4, double cz4);

		void drawWall2(	double cx1, double cy1, double cz1,
						double cx2, double cy2, double cz2,
						double cx3, double cy3, double cz3,
						double cx4, double cy4, double cz4);

		void drawWall3(	double cx1, double cy1, double cz1,
						double cx2, double cy2, double cz2,
						double cx3, double cy3, double cz3,
						double cx4, double cy4, double cz4);	

		// Modifiers
		void setActive(int act);
		void setType(int type);
		void setCoords(double cx1, double cy1, double cz1,
		               double cx2, double cy2, double cz2,
		               double cx3, double cy3, double cz3,
		               double cx4, double cy4, double cz4);

	private:

		int drawType;
		int isActive;

		double x1, y1, z1;
		double x2, y2, z2;
		double x3, y3, z3;
		double x4, y4, z4;

};
#endif
